% ECG, ecualizador grafico
%
%
%
% espen moberg, 2006
%
% Modified: Torbjrn Ursin, 2007

function ecg (va) 
global s p q hax hgrf hqgrf hsli htxt hqsli hqtxt hriple rango...
    frecs bandas
input='instruments\slow4';
% input='instruments\fast4';

if nargin < 1,
    va = 'dn1012';
    s = tf('s');
end

switch (va(1))
    case 'd' % inicializar valores y dibujar la ventana, 
             % el programa
        % valores
        bandas = eval(va(3:4));
        rango = eval(va(5:end));
        switch bandas
            case 31
                frecs = [20 25 31.5 40 50 63 80 100 125 160 ...
                    200 250 315 400 500 630 800 1000 1250 1600 ...
                    2000 2500 3150 4000 5000 6300 8000 10000 ...
                    12500 16000 20000];
            otherwise
                frecs = [31.5 63 125 250 500 1000 2000 4000 ...
                    8000 16000];
        end
        bandas = length(frecs);
        p = zeros(1,bandas); % matriz con los valores del 
                             % los pots (en dB)
        q = 1.6;

        %ventana
        close all
        figure;

        % grafico principal
        ga = 0.6; % ancha del graf
        axpos = [0.1 0.55 ga*1.1 0.4];
        hax = axes('position', axpos); % handle de los axes
        h_min = ec(zeros(1, bandas), frecs, 0.5);
        h_max = ec(ones(1, bandas), frecs, 0.5);
        [h f] = ec(p/(2*rango)+0.5, frecs, q);
        hgrf=plot(f,abs(h)); % handle del plot
        axis(hax,[min(f) max(f) min(abs(h_min))*... 
            0.9 max(abs(h_max))*1.1]);
        set(hgrf, 'parent', hax);
        set(hax, 'xscale', 'log');
        set(hax, 'yscale', 'log');
        set(hax, 'xtick', frecs);
        yt = sort([1 max(abs(h_max)) min(abs(h_min))...
                   10^(rango/10) 10^(-rango/10)]);
        set(hax, 'ytick', yt);
        set(hax, 'yticklabel', [num2str((10 * log10(yt))',3)...
                                repmat(' dB',size(yt,2),1)]);
        set(hax, 'ygrid', 'on');
        set(hax, 'yminorgrid', 'off');
        set(hax, 'xgrid', 'on');
        set(hax, 'xminorgrid', 'off');
        set(hax, 'fontsize', 10);
        
        % grafico Q
        hqax = axes('position', [0.8 0.75 0.15 0.15]);
        [z f] = zcalc(q,1000);
        hqgrf = plot(f,1./abs(z));
        set(hqax, 'xscale', 'log');
        set(hqax, 'yscale', 'log');
        axis(hqax,[min(f) max(f) ...
                   min(1./abs(z))*0.9 max(abs(1./z))*1.1]);
        set(hqax, 'ytick', []);
        set(hqax, 'xtick', []);
        set(hqax, 'fontsize', 10)

        % sliders
        for i = 1:bandas
            hsli(i) = uicontrol('style', 'slider', ...
                'value', (round(100*p(i)))/100, ...
                'min', -rango, 'max', rango, ...
                'sliderstep', [round(1/(2*rango)) ...
                round(6/(2*rango))], ...
                'unit', 'normalized', ...
                'position', ...
                    [0.13+(ga/(bandas-1)*(i-1))-ga/bandas/2 ...
                    0.1 ga/bandas 0.38], ...
                'tooltipstring', ...
                    [num2str((round(p(i)*100))/100) ' dB'], ...
                'callback', ['ecg ss' num2str(i)], ...
                'fontsize', 10 );
            htxt(i) = uicontrol('style', 'text', ...
                'string', (round(100*p(i)))/100, ...
                'backgroundcolor', [0.8 0.8 0.8], ...
                'unit', 'normalized', ...
                'position', ...
                    [0.13+(ga/(bandas-1)*(i-1))-ga/bandas/2 0 ...
                    ga/bandas 0.1], ...
                'fontsize', 10);
        end

        % q-slider
        hqsli = uicontrol('style', 'slider', ...
            'value', log10(q), ...
            'min', log10(0.1), 'max', log10(10), ...
            'sliderstep', [0.005 0.1], ...
            'unit', 'normalized', ...
            'position', [0.8 0.7 0.15 0.04], ...
            'tooltipstring', ['Q = ' num2str(q)], ...
            'callback', 'ecg qs', ...
            'fontsize', 10 );

        % q-texto
        hqtxt = uicontrol('style', 'text', ...
            'string', ['Q = ' num2str(q)], ...
            'backgroundcolor', [0.8 0.8 0.8], ...
            'unit', 'normalized', ...
            'position', [0.8 0.65 0.15 0.04], ...
            'fontsize', 10);

        % riple-texto
        hriple = uicontrol('style', 'text', ...
            'string', 'Ripple = ', ...
            'backgroundcolor', [0.8 0.8 0.8], ...
            'unit', 'normalized', ...
            'position', [0.8 0.6 0.15 0.04], ...
            'fontsize', 10);

        % salto-botones
        alts = [0.4 0.27 0.14];
        for i=1:3
            hsalto(i) = uicontrol('style', 'pushbutton', ...
                'string', '->', ...
                'backgroundcolor', [0.8 0.8 0.8], ...
                'unit', 'normalized', ...
                'position', [0.05 alts(i) 0.04 0.04], ...
                'callback', ['ecg Sn' num2str(i)], ...
                'fontsize', 10 );
        end

        % escuchar-boton
        heschuchar = uicontrol('style', 'pushbutton', ...
            'string', 'OK', ...
            'backgroundcolor', [0.8 0.8 0.8], ...
            'unit', 'normalized', ...
            'position', [0.8 0.1 0.15 0.04], ...
            'callback', 'ecg en', ...
            'fontsize', 10, ...
            'fontweight', 'b' );
        
        % elegir entre 6 y 12 dB
        dbvalores = [6 12];
        dbpos = [0.8 0.87];
        for i=1:length(dbvalores)
            hdbel(i) = uicontrol('style', 'radiobutton', ...
                'string', [num2str(dbvalores(i)) 'dB'], ...
                'value', (dbvalores(i) == rango), ...
                'backgroundcolor', [0.8 0.8 0.8], ...
                'unit', 'normalized', ...
                'position', [dbpos(i) 0.92 0.1 0.04], ...
                'callback', ['ecg dn' num2str(bandas) ...
                                num2str(dbvalores(i))], ...
                'fontsize', 8 );
        end

    case 'q' % cambiar? el valor de q
        q=10^(get(hqsli,'value'));
        set(hqsli, 'tooltipstring', ['Q = ' num2str(q)]);
        set(hqtxt, 'string', ['Q = ' num2str(q)]);
        [z f] = zcalc(q,1000);
        set(hqgrf,'xdata',f, 'ydata',abs(1./z));
    case 's' % cambiar? un slider
        ind = eval(va(3:end));
        p(ind)=get(hsli(ind),'value');
        set(hsli(ind), 'tooltipstring', [num2str(p(ind)) ' dB']);
        set(htxt(ind), 'string', p(ind));
    case 'S' % cambiar todos los sliders
        pres(1,:) = ones(1,bandas);
        pres(2,:) = 0.5 * ones(1,bandas);
        pres(3,:) = zeros(1,bandas);
        pres(4,:) = 0.5 * ones(1,bandas); pres(4,1) = 0; 
            pres(4,2) = 1;
        pres(5,:) = 0.5 * ones(1,bandas); 
            pres(5,ceil(bandas/2)+1) = 1;
        pres(6,:) = 0.5 * ones(1,bandas); 
            pres(6,ceil(bandas/2)+1) = 0;
        pres(7,:) = zeros(1,bandas); 
            pres(7,ceil(bandas/2)+1) = 1;
        pres(8,:) = ones(1,bandas); 
            pres(8,ceil(bandas/2)+1) = 0;
        switch bandas
            case 10
            case 31
        end
        pre = rango * 2 * (pres(eval(va(3:end)),:) - 0.5);
        for ind=1:bandas
            set(hsli(ind), 'value', pre(ind));
            ecg(['sn' num2str(ind)]);
        end
        ecg('as');
    case 'e' % escuchar
        [h f H] = ec(p/(2*rango)+0.5, frecs, q, rango);
        [x,fs]=wavread(input);
%         [x,fs]=wavread('utopia.wav');
        t = 0:1/fs:length(x)/fs-1/fs;
        y = lsim(H,x,t);
%         sound(y/4,fs);
        eqout=y/4;
        save eqoutbj3 eqout
end
if (va(2) ~= 'n')
    [h f] = ec(p/(2*rango)+...
        0.5,frecs,q,rango); % dar el vector con valores 
                            % entre 0 y 1
% [h f] = ec(sign(p).*real(log10(abs(p/rango*9)+1))/2+...
% 0.5,frecs,q,rango);...
                            % dar el vector con valores 
                            % entre 0 y 1
    f_intersant = [20 125 250 500 700 1000 2000 3993 ...
                   7973 16000 20000];
    for counter=1:11
        i = find(f>=f_intersant(counter),1);
        disp([num2str(round(f(i))) ': ' ...
            num2str(10*log10(abs(h(i)))) ])
    end
    disp(' ')
%     f(i) % nesten internast
    set(hgrf,'xdata',f, 'ydata',abs(h));
    set(hriple,'string',['Ripple: ' ...
        num2str(10*log(riple(h, f, frecs))) ' dB']);
end
