clear all
global fs noS duration t operations verbosityLevel wb

% Adjustable parameters
noS=3;                      % Number of speakers
instrument='fast4';         % Instrument to play
verbosityLevel=1;           % 0 for no figures, 2 for all figures
aif='asio';                  % Audio interface ('win' or 'asio')
dev=1;                      % Device no. (pa_wavplay for an overview)

%%
[snd,fs]=wavread(['instruments/' instrument]);
duration=length(snd)/fs; % 3.1, 11.7 or 19.6 for the clarinet; 65 for the guitar

if min(size(snd))==2
    snd=.5*(snd(:,1)+snd(:,2));
end
snd=snd(1:round(duration*fs));

orig=snd;
rand('state',0);
randn('state',0);

operations=5;
wb=waitbar(0,'Manipulating timing...');
snd=timedelay3(snd);
snd=spectilt(snd);
snd=ampvar(snd);
snd=decorrIIR(snd,rand(128,2*noS));
snd=adj(snd);
waitbar(1,wb,'Complete.')
close(wb)

%%
orig=[orig;zeros(length(snd)-length(orig),1)];
if verbosityLevel==1||verbosityLevel==2
    colors=['r';'g';'b';'c';'m';'y';'k';'r';'g';'b';'c';'m';'y';'k';'r';'g';'b';'c';'m';'y';'k'];
    figure(1)
    subplot 211
    t=linspace(0,duration,length(orig));
    plot(t,orig,'k')
    ylim([-1.2*max(orig) 1.2*max(orig)])
    title('Original sound file')
    drawnow
end

%%
% save simulfast snd
% play(snd,dev,aif)
stereotize(snd,fs,dev,aif)
% load sndwi;
% stereotize(snd,fs,dev,aif)

