function [z, f, Z, c1, c2] = zcalc(q, f0, f, rs, k, metodo)
if nargin < 1, q = 1; end
if nargin < 2, f0 = 500; end     
if nargin < 3, f = logspace(log10(20), log10(20000)); end
if nargin < 4, rs = 500; end  
if nargin < 5, k = 20; end  
if nargin < 6, metodo = 4; end  

global s;
if nargout < 1,
    s = tf('s');
end

gb = 15e6;
w0 = 2 * pi * f0;
w = 2 * pi * f;
switch (metodo)
case 1
    r1 = k * rs;
    r2 = rs;
    c1 = 1 / (q * rs * w0);
    c2 = q / (k * rs * w0);
    z = 1 ./ (c1 * j .* w) + r2 + r1 * r2 * c2 * j .* w;
    Z = 1 / (c1 * s) + r2 + r1 * r2 * c2 * s;
case 2
    r1 = k * rs;
    r2 = rs;
    c1 = 1 / (q * rs * w0);
    c2 = q / (k * rs * w0);
    z = 1./(c1*j.*w)+(r2.*(1 + r1 * c2 * j .* w).*...
        (1 + j .* w / gb) ./ (1 + (r2 * c2 + 1 / gb) * ...
        j .* w + (r1 + r2) * c2 / gb .* (j .* w).^2));
    Z = 1 / (c1 * s) + (r2 * (1 + r1 * c2 * s) * (1 + s / gb) ...
        / (1 + (r2 * c2 + 1 / gb) * s + (r1 + r2) * c2 / gb * s^2));
case 3
    r = rs / 2;
    c1 = 1 / (q * rs * w0);
    c2 = 4 * q / (rs * w0);
    z = 1 ./ (c1 * j .* w) + 2 * r + r^2 + r^2 * c2 * j .* w;
    Z = 1 / (c1 * s) + 2 * r + r^2 + r^2 * c2 * s;
case 4
    r = rs / 2;
    c1 = 1 / (q * rs * w0);
    c2 = 4 * q / (rs * w0);
    z = 1./(c1 * j .* w)+r.*(2 + r * c2 * j .* w) .* ...
        (1 + j .* w / gb) ./ (1 + j .* w / gb + r * c2 ...
        / gb .* (j .* w).^2);
    Z = 1 / (c1 * s) + r * (2 + r * c2 * s) * (1 + s / gb) / ...
        (1 + s / gb + r * c2 / gb * s^2);
end

if nargout < 1,
    close all;
    figure(1);
    ax = axes;
    grf=plot(f,abs(z)); 
    hold on;
    [xxx,fff] = bode(Z,f*2*pi)
    xx = 1:size(xxx,3);
    ff = 1:size(fff,3);
    xx(:) = xxx(1,1,:)
    ff(:) = fff(1,1,:)
    plot(f,abs(xx),'k');
    hold off;
    set(ax, 'xscale', 'log');
    set(ax, 'yscale', 'log');
    axis(ax,[min(f) max(f) min(min(abs(z))) max(max(abs(z)))]);
    h = 0;
    f = 0;
else
    return
end
